Open CASCADE Technology: BRepFill_LocationLaw Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Protected Member Functions | Protected Attributes
BRepFill_LocationLaw Class Reference

Location Law on a Wire. More...

`#include <BRepFill_LocationLaw.hxx>`

Inheritance diagram for BRepFill_LocationLaw:
[legend]

## Public Member Functions
GeomFill_PipeError | GetStatus () const
| Return a error status, if the status is not PipeOk then it exist a parameter tlike the law is not valuable for t. More...
virtual void | TransformInG0Law ()
| Apply a linear transformation on each law, to have continuity of the global law beetween the edges. More...
virtual void | TransformInCompatibleLaw (const Standard_Real AngularTolerance)
| Apply a linear transformation on each law, to reduce the dicontinuities of law at one rotation. More...
void | DeleteTransform ()
Standard_Integer | NbHoles (const Standard_Real Tol=1.0e-7)
void | Holes (TColStd_Array1OfInteger &Interval) const
Standard_Integer | NbLaw () const
| Return the number of elementary Law. More...
const Handle < GeomFill_LocationLaw > & | Law (const Standard_Integer Index) const
| Return the elementary Law of rank <Index> <Index> have to be in [1, NbLaw()]. More...
const TopoDS_Wire & | Wire () const
| return the path More...
const TopoDS_Edge & | Edge (const Standard_Integer Index) const
| Return the Edge of rank <Index> in the path <Index> have to be in [1, NbLaw()]. More...
TopoDS_Vertex | Vertex (const Standard_Integer Index) const
| Return the vertex of rank <Index> in the path <Index> have to be in [0, NbLaw()]. More...
void | PerformVertex (const Standard_Integer Index, const TopoDS_Vertex &InputVertex, const Standard_Real TolMin, TopoDS_Vertex &OutputVertex, const Standard_Integer Location=0) const
| Compute <OutputVertex> like a transformation of <InputVertex> the transformation is given by evaluation of the location law in the vertex of rank <Index>. <Location> is used to manage discontinuities : More...
void | CurvilinearBounds (const Standard_Integer Index, Standard_Real &First, Standard_Real &Last) const
| Return the Curvilinear Bounds of the <Index> Law. More...
Standard_Boolean | IsClosed () const
Standard_Integer | IsG1 (const Standard_Integer Index, const Standard_Real SpatialTolerance=1.0e-7, const Standard_Real AngularTolerance=1.0e-4) const
| Compute the Law's continuity beetween 2 edges of the path The result can be : -1 : Case Not connex 0 : It is connex (G0) 1 : It is tangent (G1) More...
void | D0 (const Standard_Real Abscissa, TopoDS_Shape &Section)
| Apply the Law to a shape, for a given Curnilinear abscissa. More...
void | Parameter (const Standard_Real Abscissa, Standard_Integer &Index, Standard_Real &Param)
| Find the index Law and the parmaeter, for a given Curnilinear abscissa. More...
Standard_Real | Abscissa (const Standard_Integer Index, const Standard_Real Param)
| Return the curvilinear abscissa corresponding to a point of the path, defined by <Index> of Edge and a parameter on the edge. More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Protected Member Functions
void | Init (const TopoDS_Wire &Path)
| Initialize all the fields, this methode have to be called by the constructors of Inherited class. More...
void | TangentIsMain ()
| To preseve if possible the Tangent in transformations It is the default mode. More...
void | NormalIsMain ()
| To preseve if possible the Normal in transformations. More...
void | BiNormalIsMain ()
| To preseve if possible the BiNormal in transformations. More...

## Protected Attributes
TopoDS_Wire | myPath
Standard_Real | myTol
Handle < GeomFill_HArray1OfLocationLaw > | myLaws
Handle< TColStd_HArray1OfReal > | myLength
Handle< TopTools_HArray1OfShape > | myEdges
Handle< TColStd_HArray1OfInteger > | myDisc

## Detailed Description

Location Law on a Wire.

## Member Function Documentation

Standard_Real BRepFill_LocationLaw::Abscissa | ( | const Standard_Integer | Index,
|  | const Standard_Real | Param
| ) |  |

Return the curvilinear abscissa corresponding to a point of the path, defined by <Index> of Edge and a parameter on the edge.

void BRepFill_LocationLaw::BiNormalIsMain | ( |  | ) |
| protected

To preseve if possible the BiNormal in transformations.

void BRepFill_LocationLaw::CurvilinearBounds | ( | const Standard_Integer | Index,
|  | Standard_Real & | First,
|  | Standard_Real & | Last
| ) |  | const

Return the Curvilinear Bounds of the <Index> Law.

void BRepFill_LocationLaw::D0 | ( | const Standard_Real | Abscissa,
|  | TopoDS_Shape & | Section
| ) |  |

Apply the Law to a shape, for a given Curnilinear abscissa.

void BRepFill_LocationLaw::DeleteTransform | ( |  | ) |

const TopoDS_Edge& BRepFill_LocationLaw::Edge | ( | const Standard_Integer | Index | ) | const

Return the Edge of rank <Index> in the path <Index> have to be in [1, NbLaw()].

GeomFill_PipeError BRepFill_LocationLaw::GetStatus | ( |  | ) | const

Return a error status, if the status is not PipeOk then it exist a parameter tlike the law is not valuable for t.

void BRepFill_LocationLaw::Holes | ( | TColStd_Array1OfInteger & | Interval | ) | const

void BRepFill_LocationLaw::Init | ( | const TopoDS_Wire & | Path | ) |
| protected

Initialize all the fields, this methode have to be called by the constructors of Inherited class.

Standard_Boolean BRepFill_LocationLaw::IsClosed | ( |  | ) | const

Standard_Integer BRepFill_LocationLaw::IsG1 | ( | const Standard_Integer | Index,
|  | const Standard_Real | SpatialTolerance = `1.0e-7`,
|  | const Standard_Real | AngularTolerance = `1.0e-4`
| ) |  | const

Compute the Law's continuity beetween 2 edges of the path The result can be : -1 : Case Not connex 0 : It is connex (G0) 1 : It is tangent (G1)

const Handle< GeomFill_LocationLaw >& BRepFill_LocationLaw::Law | ( | const Standard_Integer | Index | ) | const

Return the elementary Law of rank <Index> <Index> have to be in [1, NbLaw()].

Standard_Integer BRepFill_LocationLaw::NbHoles | ( | const Standard_Real | Tol = `1.0e-7` | ) |

Standard_Integer BRepFill_LocationLaw::NbLaw | ( |  | ) | const

Return the number of elementary Law.

void BRepFill_LocationLaw::NormalIsMain | ( |  | ) |
| protected

To preseve if possible the Normal in transformations.

void BRepFill_LocationLaw::Parameter | ( | const Standard_Real | Abscissa,
|  | Standard_Integer & | Index,
|  | Standard_Real & | Param
| ) |  |

Find the index Law and the parmaeter, for a given Curnilinear abscissa.

void BRepFill_LocationLaw::PerformVertex | ( | const Standard_Integer | Index,
|  | const TopoDS_Vertex & | InputVertex,
|  | const Standard_Real | TolMin,
|  | TopoDS_Vertex & | OutputVertex,
|  | const Standard_Integer | Location = `0`
| ) |  | const

Compute <OutputVertex> like a transformation of <InputVertex> the transformation is given by evaluation of the location law in the vertex of rank <Index>. <Location> is used to manage discontinuities :

- -1 : The law before the vertex is used.
- 1 : The law after the vertex is used.
- 0 : Average of the both laws is used.

void BRepFill_LocationLaw::TangentIsMain | ( |  | ) |
| protected

To preseve if possible the Tangent in transformations It is the default mode.

virtual void BRepFill_LocationLaw::TransformInCompatibleLaw | ( | const Standard_Real | AngularTolerance | ) |
| virtual

Apply a linear transformation on each law, to reduce the dicontinuities of law at one rotation.

virtual void BRepFill_LocationLaw::TransformInG0Law | ( |  | ) |
| virtual

Apply a linear transformation on each law, to have continuity of the global law beetween the edges.

TopoDS_Vertex BRepFill_LocationLaw::Vertex | ( | const Standard_Integer | Index | ) | const

Return the vertex of rank <Index> in the path <Index> have to be in [0, NbLaw()].

const TopoDS_Wire& BRepFill_LocationLaw::Wire | ( |  | ) | const

return the path

## Field Documentation

Handle< TColStd_HArray1OfInteger > BRepFill_LocationLaw::myDisc
| protected

Handle< TopTools_HArray1OfShape > BRepFill_LocationLaw::myEdges
| protected

Handle< GeomFill_HArray1OfLocationLaw > BRepFill_LocationLaw::myLaws
| protected

Handle< TColStd_HArray1OfReal > BRepFill_LocationLaw::myLength
| protected

TopoDS_Wire BRepFill_LocationLaw::myPath
| protected

Standard_Real BRepFill_LocationLaw::myTol
| protected

The documentation for this class was generated from the following file:

- BRepFill_LocationLaw.hxx